<template>
  <div>
    <el-card class="el-card">
      <el-form :model="listQuery" label-width="120px" v-if="showSearch">
        <el-row>
          <el-col :span="18">
            <el-form-item label="UDI码:" class="query-form-item">
              <el-input v-model="listQuery.udiCode" style="width: 96%" placeholder="请扫描或输入UDI码" clearable="true"
                        @keyup.enter.native="keyup_submit($event)"></el-input>
            </el-form-item>
          </el-col>
          <!--          <el-col :span="6">-->
          <!--            <el-form-item label="第三方物资编码:" class="query-form-item">-->
          <!--              <el-input v-model="listQuery.thrPiId" style="width: 90%" placeholder="请输入第三方物资编码"-->
          <!--                        clearable="true"></el-input>-->
          <!--            </el-form-item>-->
          <!--          </el-col>-->
        </el-row>

        <el-row>
          <el-col :span="8">
            <el-form-item label="物品编码:" class="query-form-item">
              <el-input v-model="listQuery.unionCode" style="width: 90%" placeholder="请输入DI/医保编码/商品条码"
                        clearable="true"></el-input>
            </el-form-item>
          </el-col>
          <el-col :span="8">
            <el-form-item label="产品通用名:" class="query-form-item">
              <el-input v-model="listQuery.cpmctymc" style="width: 90%" placeholder="请输入产品通用名"
                        clearable="true"></el-input>
            </el-form-item>
          </el-col>
          <el-col :span="8">
            <el-form-item label="规格型号:" class="query-form-item">
              <el-input v-model="listQuery.ggxh" style="width: 90%" placeholder="请输入规格型号" clearable="true"></el-input>
            </el-form-item>
          </el-col>
        </el-row>

        <el-row>

          <el-col :span="8">
            <el-form-item label="生产企业:" class="query-form-item">
              <el-input v-model="listQuery.manufactory" style="width: 90%" placeholder="请输入生产企业"
                        clearable="true"></el-input>
            </el-form-item>
          </el-col>

          <el-col :span="8">
            <el-form-item label="注册/备案证号:" class="query-form-item">
              <el-input v-model="listQuery.zczbhhzbapzbh" style="width: 90%" placeholder="注册/备案证号"
                        clearable="true"></el-input>
            </el-form-item>
          </el-col>
        </el-row>

      </el-form>

      <div class="top-right-btn">
        <el-button-group style="display:flex;">
          <el-button icon="el-icon-view" type="primary" @click="hideSearch">显示/隐藏搜索栏</el-button>
          <el-button type="primary" icon="el-icon-refresh" @click="onReset">重置</el-button>
          <el-button type="primary" icon="el-icon-search" @click="search">查询</el-button>
          <el-button type="primary" icon="el-icon-plus" @click="confirmSelect">确定</el-button>
        </el-button-group>
      </div>
      <el-divider style="margin: 15px"></el-divider>

      <el-table :data="dataList" style="width: 100%" v-loading="loading" border highlight-current-row
                :row-class-name="tableRowClassName" @current-change="handleChange" ref="multipleTable">
        <el-table-column label width="45">
          <template slot-scope="scope">
            <el-radio :label="scope.row.id" v-model="radioCheck"><span></span></el-radio>
          </template>
        </el-table-column>
        <el-table-column label="序号" type="index"></el-table-column>
        <el-table-column label="DI/物资编码" prop="nameCode" width="140" show-overflow-tooltip></el-table-column>
        <el-table-column label="物资名称" prop="cpmctymc" show-overflow-tooltip width="140"></el-table-column>
        <el-table-column label="规格型号" prop="ggxh" show-overflow-tooltip width="140"></el-table-column>
        <el-table-column label="计量单位" prop="measname" show-overflow-tooltip width="100"></el-table-column>
        <el-table-column label="价格" prop="price" width="100"></el-table-column>
        <el-table-column label="生产企业" prop="manufactory" show-overflow-tooltip width="160"></el-table-column>
        <el-table-column label="注册/备案凭证" prop="zczbhhzbapzbh" show-overflow-tooltip width="160"></el-table-column>
        <el-table-column label="配送企业" prop="companyName" show-overflow-tooltip width="160"></el-table-column>
        <el-table-column label="操作" width="90" fixed="right">
          <template slot-scope="scope">
            <el-button type="text" size="small" @click.native.stop="handleDetailClick(scope.row)">详情</el-button>
          </template>
        </el-table-column>
      </el-table>

      <pagination
        v-show="pageTotal>0"
        :total="pageTotal"
        :page.sync="listQuery.page"
        :limit.sync="listQuery.limit"
        @pagination="handleErpPageChange"

      ></pagination>
    </el-card>


    <el-dialog
      title="耗材字典详情"
      :visible.sync="udiRlDetailVisible"
      width="80%"
      :close-on-click-modal="false"
      :close-on-press-escape="false"
      append-to-body
      v-if="udiRlDetailVisible"
    >
      <udiRlDetailDialog :editQuery="currentRow"></udiRlDetailDialog>
    </el-dialog>

    <el-dialog title="请选择对应的注册/备案证" :visible.sync="dialogFormVisible" append-to-body width="40%">
      <el-form :model="form">
        <el-form-item label="" prop="isGive">
          <el-radio-group v-model="currentCert">
            <el-radio style="width: 100%;  margin-top: 10px;" :label="item" :key="item" v-for="item in certList">{{
                item
              }}
            </el-radio>
          </el-radio-group>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="selectCert">确 定</el-button>
        <el-button @click="dialogFormVisible = false">取 消</el-button>
      </div>
    </el-dialog>

  </div>
</template>

<script>
import {filterCompanyProductRelevance} from "../../../api/basic/udiRlSuptRelevance";
import store from "../../../store";
import {addOrderDetail} from "@/api/purchase/purOrder"
import udiRlDetailDialog from "./../../purchase/purApply/purUdiRlDetailDialog";
import {isBlank} from "@/utils/strUtil";

export default {
  name: "stockOrderNewSelectProduct",
  props: {
    data: {
      type: Object,
      required: true,
    },
    closeDialog: {
      type: Function,
      required: true,
    },
    purType: {
      type: Object,
      required: true,
    },
    pId: {
      type: Object,
      required: true,
    },
    supId: {
      type: Object,
      required: true,
    },
  },

  data() {
    return {
      showSearch: true,
      listQuery: {
        purType: null,
        udiCode: null,
        unicode: null,
        cpmctymc: null,
        ggxh: null,
        ylqxzcrbarmc: null,
        thrPiId: null,
        page: 1,
        limit: 10,
        zczbhhzbapzbh: null,
        manufactory: null,

        basicPrductRemak1: null,
        basicPrductRemak2: null,
      },
      combineQuery: {
        thirdId: "",
        relId: "",
        erpName: "",
        keys: [],
      },
      ids: [],
      radioCheck: null,
      dataList: [],
      pageTotal: 1,
      total: 1,
      currentRow: null,
      loading: false,
      udiRlDetailVisible: false,
      thirdSys: [],
      thirdSysFk: null,
      busTypes: [],
      actDateRange: [],
      pickerOptions: {
        shortcuts: [
          {
            text: "最近一周",
            onClick(picker) {
              const end = new Date();
              const start = new Date();
              start.setTime(start.getTime() - 3600 * 1000 * 24 * 7);
              picker.$emit("pick", [start, end]);
            },
          },
          {
            text: "最近一个月",
            onClick(picker) {
              const end = new Date();
              const start = new Date();
              start.setTime(start.getTime() - 3600 * 1000 * 24 * 30);
              picker.$emit("pick", [start, end]);
            },
          },
          {
            text: "最近三个月",
            onClick(picker) {
              const end = new Date();
              const start = new Date();
              start.setTime(start.getTime() - 3600 * 1000 * 24 * 90);
              picker.$emit("pick", [start, end]);
            },
          },
        ],
      },
      orderEditor: false,
      orderId: "",
      currentCert: null,
      certList: [],
      dialogFormVisible: false,
      multipleSelection: null,
    };
  },
  methods: {
    onReset() {
      this.$router.push({
        path: "",
      });
      this.listQuery = {
        purType: null,
        udiCode: null,
        unicode: null,
        cpmctymc: null,
        ggxh: null,
        ylqxzcrbarmc: null,
        thrPiId: null,
        page: 1,
        limit: 10
      }
      this.multipleSelection = [];
      this.radioCheck = null;
      this.currentRow = null;
      this.getList();
    },
    hideSearch() {
      this.showSearch = !this.showSearch;
    },
    tableRowClassName({row}) {
      if (row.checked) return "warning-row";
      return "";
    },
    checkSelectable(row) {
      return !row.check;
    },
    handleCurrentChange(val) {
      this.unionQuery.page = val;
      this.getList();
    },
    handleChange(val) {
      this.radioCheck = val.id;
      this.currentRow = val;
      this.multipleSelection = val
    },
    handleDetailClick(row) {
      this.currentRow = row;
      this.udiRlDetailVisible = true;

    },
    handleErpPageChange(val) {
      this.listQuery.page = val.page;
      this.getList();
    },
    keyup_submit(event) {
      this.listQuery.page = 1;
      this.getList();
      event.target.select();
    },
    search() {
      this.listQuery.page = 1;
      this.getList();
    },
    getList() {
      this.loading = true;
      this.listQuery.customerId = store.getters.customerId;
      this.listQuery.unitFk = this.supId;
      filterCompanyProductRelevance(this.listQuery)
        .then((response) => {
          this.loading = false;
          if (response.code === 20000) {
            this.dataList = response.data.list || [];
            this.pageTotal = response.data.total || 0;
          } else {
            this.$message.error(response.message);
            this.dataList = [];
            this.pageTotal = 0;
          }
        })
        .catch(() => {
          this.loading = false;
          this.dataList = [];
          this.pageTotal = 0;
        });
    },
    intentBack() {
      this.closeDialog();
    },


    confirmSelect() {
      if (this.multipleSelection == null) {
        this.$message.error('未选择产品');
        return;
      }

      if (this.ids.length > 0) {
        for (var i = 0; i < this.ids.length; i++) {
          if (this.ids[i] == this.multipleSelection.rlId) {
            this.$message.error("该产品已录入！");
            return
          }
        }
      }
      let str = this.multipleSelection.zczbhhzbapzbh;
      if (!isBlank(str) && str.search(",") != -1) {
        this.currentCert = null;
        this.certList = str.split(',');
        this.dialogFormVisible = true;
      } else {
        this.combine();
      }
    },

    combine() {
      this.loading = true;
      let tQuery = {
        productId: this.multipleSelection.rlId,
        productName: this.multipleSelection.cpmctymc,
        count: 1,
        orderIdFk: this.pId,
        supId: this.multipleSelection.customerId,
        zczbhhzbapzbh: this.multipleSelection.zczbhhzbapzbh,
        price: this.multipleSelection.price
      };
      addOrderDetail(tQuery).then((response) => {
        this.loading = false;
        if (response.code === 20000) {
          this.closeDialog(response.data);
        } else {
          if (response.code == 601) {
            this.$alert(response.message, "提示", {
              confirmButtonText: "确定",
            });
          } else
            this.$message.error(response.message);
        }
      }).catch(() => {
        this.loading = false;
      });

    },

    selectCert() {
      if (this.currentCert == null) {
        this.$message.error("请先选择对应的注册证！");
      } else {
        this.multipleSelection.zczbhhzbapzbh = this.currentCert;
        this.combine();
      }

    },
  },
  components: {udiRlDetailDialog},

  created() {
    console.log(this.data)
    if (this.$isNotBlank(this.data)) {
      this.ids = [];
      if (this.data.stockOrderLists.length > 0) {
        for (var i = 0; i < this.data.stockOrderLists.length; i++) {
          this.ids.push(this.data.stockOrderLists[i].productId);
        }
      }
    }

    this.getList();

  },
};
</script>

<style scoped>


div /deep/ .el-table .warning-row {
  background: #bebebe;
}

div /deep/ .el-table .success-row {
  background: #ffffff;
}
</style>
